﻿;Teploměr se servem

setfreq m4		 ;nastaví frekvenci 4MHz

w3=155		 ; nastaveni serva na střed stupnice
low 1			 ; zapne napájení serva

for w2=0 to 500	 ; pošle do serva 500 impulsů, to trvá 10 sec.
	pulsout 2,w3 ; výstup jednoho impulsu
	pause 18     ; čekání asi 20ms
next w2
;servo čekalo ve středu stupnice pro kontrolu 10 sekund.
;_______________________________________________________
cykl:			 ;hlavní programová smyčka
w8=w8+1 		 ;počítání cyklů bez ovládání serva 

readtemp12 4,w0	 ;čte se teplota z čidla
w0=w0 max 528 min 272 ;meze měření 17°C - 33°C, omezení aby servo nejezdilo na krajní dorazy
w4=w0/16		;údaj ve °C (jen pro info v debug)
w6=w0-w10        	;porovnání s minulou hodnotou teploty
w7=w10-w0
debug

;Přepočet údaje sondy na kroky serva
w11=w0-288		;288/16=18°C počátek stupnice
w12=w11*11		;servo má 11 kroků na 1°C
w5=w12/16 + 78	;čidlo má 16 údajů na 1°C, 78 je začátek stupnice
			;w5 je poloha serva před korekcí

if w8>4 then gosub korekce ;nastavení bez hystereze po 920 sec.
if w6<3 then goto spanek   ;hystereze 0,27°C
if w7<3 then goto spanek   ;hystereze 0,27°C


gosub korekce	;skok na provedení korekce linearity serva

goto cykl
;_____________________________________________________

korekce:
if w5>222 then goto jedna ;korekce podle polohy serva
if w5>206 then goto dva
if w5>190 then goto tri
if w5>174 then goto ctyri
if w5>158 then goto pet
if w5>142 then goto sest
if w5>126 then goto sedm
if w5>110 then goto osm
if w5>94  then goto devet
if w5>77  then goto deset  ;77 musí být menší než začátek stupnice 78

return

jedna:w1=w5+0 	goto vystup ;korekce podle polohy serva
dva: 	w1=w5+0 	goto vystup ;w1 je poloha serva po korekci
tri: 	w1=w5+0	goto vystup
ctyri:w1=w5+1	goto vystup
pet: 	w1=w5-0 	goto vystup
sest: w1=w5-1 	goto vystup
sedm: w1=w5-1	goto vystup
osm: 	w1=w5-0 	goto vystup
devet:w1=w5+0	goto vystup
deset:w1=w5-0 	goto vystup
;____________________________________________________________________

vystup:

low 1			 ; zapne napájení serva

for w2=0 to 10	 ; pošle do serva 10 impulsů
	pulsout 2,w1 ; výstup jednoho impulsu
	pause 18     ; čekání asi 20ms
next w2
high 1		 ; vypne napájení serva

w10=w0		 ;zapamatování teploty pro příští porovnání
w8=0			 ;vynulování počítadla hystereze
return

spanek:
sleep 100		; spánek 100x2.3=230 sec = 3,8 min
goto cykl
